<?php
if (!empty($_SERVER['SCRIPT_FILENAME']) && 'addonscore.php' == basename($_SERVER['SCRIPT_FILENAME'])) die ('Please do not load this page directly. Thanks!');

add_action('admin_menu', 'oqey_add_addons_pages');

function oqey_add_addons_pages(){
	$icon = WP_PLUGIN_URL.'/oqey-add-ons/images/oqeycropper.png';
    $oqeym = plugin_basename( dirname(__FILE__));
    
    add_menu_page('oQey Add-ons plugin', 'oQey Add-ons', 8, $oqeym, 'oqey_addons_top_page', $icon);	  
    add_submenu_page($oqeym, 'Roles', 'Roles', 'oQeyCropperRoles', 'oQeyCropperRoles', 'oqey_addons_roles_page');
    add_submenu_page($oqeym, 'Watermark', 'Watermark', 'oQeyWatermark', 'oQeyWatermark', 'oqey_addons_watermark_page');
}

//function oqey_cropper_page(){ include("managecropper.php"); }
function oqey_addons_roles_page(){ include("manageroles.php"); }
function oqey_addons_watermark_page(){ include("oqeywatermark.php"); }

function oqey_addons_top_page(){
?>
<div class="wrap">
        	<h2>oQey Add-ons plugin</h2>
</div>

<div id="poststuff" class="metabox-holder has-right-sidebar">
									
<div class="has-sidebar sm-padded">
	<div id="post-body-content" class="has-sidebar-content">
		<div class="meta-box-sortabless">
        
         <div id="sm_rebuild" class="postbox" style="width:870px;">
				<h3 class="hndle"><span>About</span></h3>

				<div class="inside" style="font-size:13px; padding:10px; text-align:justify;">
                <p>oQey Gallery is a Plugin for Wordpress that let users create and manage flash slideshows with a non-flash version of gallery built-in for all non-flash browsers and mobile devices like iPhone / iPad / iPod etc. The flash version supports music and skins, so users can change the way it looks with a few simple clicks. Customizable, commercial skins are also available as well as custom galleries for professionals. Check this out on <a href="http://oqeysites.com/" target="_blank">oqeysites.com</a></p>
                    <a href="http://oqeysites.com"><img style="border: none;" src="<?php echo WP_PLUGIN_URL; ?>/oqey-gallery/images/oqeybanner.jpg" /></a>

                </div>

         </div>
         
         <div class="postbox" style="width:870px;">
				<h3 class="hndle"><span>WP Themes and Site templates</span></h3>                
                  <div class="inside" style="font-size:13px;text-align:justify;"> 
	               <p>If you are interested to buy an original WP theme, oQey Sites recommends the following themes. Check it out!</p>
	               <a href="http://themeforest.net/?ref=oqeysites" target="_blank"><img style="border:none;" src="<?php echo oQeyPluginUrl(); ?>/images/tf_728x90_v5.gif" width="728" height="90" /></a>
                  </div>
         </div>

		</div>
	</div>
 </div>
</div>

<?php
}

/*..........................................................................................*/

function oqey_gallery_media_menu($tabs) {
$newtab = array('oqeytab' => __('From oQey Gallery', 'oqeygallery'));
return array_merge($tabs, $newtab);
}
add_filter('media_upload_tabs', 'oqey_gallery_media_menu');
    
function media_oqey_gallery_process() {
   media_upload_header();
   oqeygallery_featured_image();
   
}
function oqey_gallery_media_menu_handle() {
    return wp_iframe( 'media_oqey_gallery_process');
}
add_action('media_upload_oqeytab', 'oqey_gallery_media_menu_handle');

function oqeygallery_featured_image(){
    
    global $wpdb;
    
    $meta = get_post_meta($_REQUEST['post_id'], '_thumbnail_id');
    $oqey_galls = $wpdb->prefix . "oqey_gallery";
    $oqey_images = $wpdb->prefix . "oqey_images";
    
    $gals = $wpdb->get_results("SELECT * FROM $oqey_galls WHERE status!=2 ORDER BY id ASC ");
    
    echo '<div style="padding:20px;">';
    
			echo 'Choose a gallery: &nbsp;<select size="1" name="oqeygalleries" id="oqeygalleries">';
            echo '<option value="0">Select gallery</option>';
				if($gals) {
					foreach($gals as $gal) {
					echo '<option value="'.$gal->id.'" ';
					echo '>'.trim($gal->title).'</option>'."\n\t"; 
					}
				}
    
	echo '</select>';
    
    echo '&nbsp;&nbsp;&nbsp;&nbsp;Click on a thumbnail to use it as a featured image';
            
    echo '</div>';
    echo '<div id="allimages" style="width:99%; padding:1px;"></div>';
    echo '<p>&nbsp;</p>';
    
    echo '<script>
      jQuery(document).ready(function($){        
         jQuery("#oqeygalleries").change(function() {
            var id = jQuery(this).val();            
            jQuery.post( ajaxurl, { action:"oQeyAddonGetGallery", id: id, post_id: '.$_REQUEST['post_id'].' },
            function(r){		      
              jQuery("#allimages").hide().html(r).fadeIn("slow");			
            });
        });    
    });';
    
    echo "      
    function WPSetAsThumbnail2(id, imgid, nonce){
          
          var ilink = jQuery('a#wp-post-thumbnail-' + id);
          
          /* Get image ID */
          jQuery.post( ajaxurl, { action:'oQeyAddonGetImageDetails', id: imgid },
            function(r){
			
               var thumbnail_id = r;
               ilink.text( setPostThumbnailL10n.saving );
	jQuery.post(ajaxurl, {
		action:'set-post-thumbnail', post_id: post_id, thumbnail_id: thumbnail_id, _ajax_nonce: nonce, cookie: encodeURIComponent(document.cookie)
	}, function(str){
		var win = window.dialogArguments || opener || parent || top;
		ilink.text( setPostThumbnailL10n.setThumbnail );
		if ( str == '0' ) {
			alert( setPostThumbnailL10n.error );
		} else {
			jQuery('a.wp-post-thumbnail').show();
			ilink.text( setPostThumbnailL10n.done );
			ilink.fadeOut( 2000 );
			win.WPSetThumbnailID(id);
			win.WPSetThumbnailHTML(str);
		}
	}
	);    
    });    
    }
    ";    
    echo '</script>';    
    echo '<style>
          .oqey_featured_image img{ display: table-cell; text-align: center; vertical-align: middle;margin-left:auto; margin-right:auto; display:block;}
          </style>'; 
}

function oqey_addons_get_gallery_folder($id){
  global $wpdb;
  $id = (int)$id;
  $oqey_galls = $wpdb->prefix . "oqey_gallery";	
  $r = $wpdb->get_row("SELECT folder FROM $oqey_galls WHERE id ='".mysql_real_escape_string($id)."'");
  return $r->folder;
}

add_action( 'wp_ajax_oQeyAddonGetImageDetails', 'oQeyAddonGetImageDetails' );
function oQeyAddonGetImageDetails() {
    global $wpdb;
   
    $oqey_galls = $wpdb->prefix . "oqey_gallery";
    $oqey_images = $wpdb->prefix . "oqey_images";
    
    $img = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $oqey_images WHERE status!=2 AND id = %d ", (int)esc_sql( $_POST['id'] ) ));
    $folder = oqey_addons_get_gallery_folder($img->gal_id);
    
    $wpdata = wp_upload_dir();
      
    if($img->img_type=="nextgen"){
      
          $ipath = OQEY_ABSPATH.'/'.trim($img->img_path).'/';
          $img_type = "nextgen";
          $img_f_path = urlencode(trim($img->img_path));
          $imgurl = get_option('siteurl').'/'.trim($img->img_path).'/';
      
        }else{
        
          $ipath = OQEY_ABSPATH.'wp-content/oqey_gallery/galleries/'.oqey_AddonBlogFolder($wpdb->blogid).$folder.'/galimg/';
          $img_type = "oqey";
          $img_f_path = "";
          $imgurl = get_option('siteurl').'/wp-content/oqey_gallery/galleries/'.oqey_AddonBlogFolder($wpdb->blogid).$folder.'/galimg/'; 
      
    }
    
    $source = $ipath."/".trim($img->title);
    $destination = $wpdata['path']."/".trim($img->title);
    
    copy($source, $destination);
    
    $p = array();
    $p['post_title'] = $img->alt;
    $p['post_name'] =  $img->alt;
    $p['guid'] = $wpdata['url'].'/'.trim($img->title);
    $p['post_mime_type'] = 'image/jpeg';
    $p['post_type'] = 'attachment';
        
	$id = wp_insert_attachment($p);
    
    $file = $destination;//$ipath.trim($img->title);
    
    $data = wp_generate_attachment_metadata( $id, $file );
    
    update_attached_file( $id, $file );
    wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $file ) );    
    image_get_intermediate_size($id);
   
    echo $id;
    
    die();
}


add_action( 'wp_ajax_oQeyAddonGetGallery', 'oQeyAddonGetGallery' );
function oQeyAddonGetGallery() {
    global $wpdb;
   
    $oqey_galls = $wpdb->prefix . "oqey_gallery";
    $oqey_images = $wpdb->prefix . "oqey_images";
    
    $gal = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $oqey_galls WHERE status!=2 AND id = %d ", esc_sql( $_POST['id'] ) ));
    
    $images = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM $oqey_images WHERE status!=2 AND gal_id = %d AND img_type != %s ", (int)esc_sql( $_POST['id'] ), "video" ));
    
    $i = 1;
    $calling_post_id = $_POST['post_id'];
    $ajax_nonce = wp_create_nonce( "set_post_thumbnail-$calling_post_id" );
        
    foreach($images as $img){
        
        if($img->img_type=="nextgen"){
      
          $ipath = OQEY_ABSPATH.'/'.trim($img->img_path).'/';
          $img_type = "nextgen";
          $img_f_path = urlencode(trim($img->img_path));
          $imgurl = get_option('siteurl').'/'.trim($img->img_path).'/';
      
         }else{
        
          $ipath = OQEY_ABSPATH.'wp-content/oqey_gallery/galleries/'.oqey_AddonBlogFolder($wpdb->blogid).$gal->folder.'/galimg/';
          $img_type = "oqey";
          $img_f_path = "";
          $imgurl = get_option('siteurl').'/wp-content/oqey_gallery/galleries/'.oqey_AddonBlogFolder($wpdb->blogid).$gal->folder.'/galimg/'; 
      
        }
 
        if($i%2){ $lpx = 3; }else{ $lpx = 3; }

        $r .= '<div style="border:#ccc thin solid; margin-top:5px; margin-left:'.$lpx.'px; float:left; width:150px; height:102px; padding:2px;border-radius:3px;">';
        $r .= '<div class="oqey_featured_image">';
        $r .= "<a href='#' onclick='WPSetAsThumbnail2(\"$i\", \"$img->id\", \"$ajax_nonce\");return false;'>";
        $r .= '<img src="'.$imgurl.$img->title.'" style="width:auto; max-width: 150px; max-height:100px; margin-left:auto; margin-right:auto;" />';
        $r .= "</a>";
        $r .= '</div>';
        $r .= '</div>';    
        
        $i++;
    }
    
    echo $r;
    
    die();
}
?>